"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.constructLintConfig = constructLintConfig;
var _logger = require("../utils/logger");
var _getFileUtils = require("../lint/eslint/getFileUtils");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function constructLintConfig(lintFor, eslintConfPath) {
  //   const configArray = lintFor.split(',')
  var lintConfig = require((0, _getFileUtils.getConfigurationFilePath)());
  var _ref = eslintConfPath ? require((0, _getFileUtils.resolvePath)(eslintConfPath)) : lintFor ? lintConfig[lintFor] : lintConfig[lintFor],
    _ref$extends = _ref["extends"],
    $extends = _ref$extends === void 0 ? [] : _ref$extends,
    _ref$plugins = _ref.plugins,
    plugins = _ref$plugins === void 0 ? [] : _ref$plugins,
    _ref$ignorePatterns = _ref.ignorePatterns,
    ignorePatterns = _ref$ignorePatterns === void 0 ? [] : _ref$ignorePatterns,
    _ref$rules = _ref.rules,
    rules = _ref$rules === void 0 ? {} : _ref$rules,
    _ref$options = _ref.options,
    options = _ref$options === void 0 ? {} : _ref$options;
  checkPluginInstalled(plugins);
  checkPluginInstalled($extends);
  return _objectSpread(_objectSpread({}, {
    env: getLintEnv(),
    "extends": getExtends($extends),
    parserOptions: getParserOptions(),
    plugins: getPlugins(plugins),
    ignorePatterns: getIgnorePattern(ignorePatterns),
    rules: getRules(rules)
  }), getOtherOptions(options));
}
function getIgnorePattern(ignorePatterns) {
  return ignorePatterns;
}
function getLintEnv(envObjectLint) {
  return _objectSpread(_objectSpread({}, envObjectLint), {
    browser: true,
    es2021: true
  });
}
function checkPluginInstalled(plugins) {
  plugins.forEach(function (plugin) {
    try {
      require.resolve(plugin);
      return;
    } catch (err) {
      _logger.Logger.log(_logger.Logger.FAILURE_TYPE, "".concat(plugin, " is not installed. check your plugin is installed or not in package.json"));
      process.exit(0);
    }
  });
  return;
}
function getExtends($extends) {
  return $extends;
}
function getPlugins(plugins) {
  return plugins;
}
function getParserOptions() {
  return {
    ecmaFeatures: {
      jsx: true
    },
    ecmaVersion: 12,
    sourceType: "module"
  };
}
function getOtherOptions(options) {
  return options;
}
function getRules(rules) {
  return rules;
}
function mergeConfigs(configArray, lintConfig) {
  return configArray.reduce(function (entireConfig, config) {
    return entireConfig = _objectSpread(_objectSpread({}, entireConfig), lintConfig[config]);
  }, {});
}