"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterDiffJson = filterDiffJson;
exports.filterFileBasedOnLint = filterFileBasedOnLint;
exports.filterLintReportBasedOnImpactLine = filterLintReportBasedOnImpactLine;
var _path = _interopRequireDefault(require("path"));
var _getModifiedLines = require("../getModifiedLines");
var _getFileUtils = require("./getFileUtils");
var _fileUtils = require("../../utils/fileUtils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
/**
 *  if they call impact based as false then filter not apply
 */

function filterLintReportBasedOnImpactLine(lintReport, reportLineMap, filePath) {
  var impactedLines = reportLineMap.get(filePath);
  lintReport.messages = lintReport.messages.filter(function (message) {
    if (filterNotDefinedRule(message.message)) {
      return false;
    }
    if (impactedLines.includes(message.line)) {
      // To set pipeline status 
      message["severity"] == 2 ? global.reportStatus = false : null;
      return true;
    }
    return false;
  });
  return lintReport;
}
function filterDiffJson(diffJson) {
  var _diffJson$diffs;
  var diffFilesMap = new Map();
  diffJson === null || diffJson === void 0 || (_diffJson$diffs = diffJson.diffs) === null || _diffJson$diffs === void 0 || _diffJson$diffs.forEach(function (diff) {
    var diffPathKey = _path["default"].resolve((0, _getFileUtils.getRootGitPath)(), diff.new_path);
    if (diffPathKey === undefined) {
      return;
    }
    if (diffPathKey) {
      diffFilesMap.set(diffPathKey, (0, _getModifiedLines.getModifiedLines)(diff.diff).modifiedLines);
    }
  });
  return diffFilesMap;
}
function filterFileBasedOnLint(lintReport) {
  return lintReport;
  // return filterStagedFilesError(filePath,lintReport,lintFor)
}

// unused method (Used For Linters)
function filterStagedFilesError(fileName, lintReport, lintFor) {
  // first index pop for file name
  if ((0, _fileUtils.checkIfFileExists)(fileName)) {
    if (fileName.includes(lintFor.toString())) {
      return filterByErrorMessage(lintReport, 'no-hardcoding');
    }
    if (true) {
      return filterByErrorMessage(lintReport, 'playwright');
    }
  }
}
function filterByErrorMessage(lintReport, errorMessage) {
  lintReport.messages = lintReport.messages.filter(function (fileContent) {
    if (fileContent.ruleId.includes(errorMessage)) {
      return false;
    }
    return true;
  });
  return lintReport;
}

// walk through solution 
function filterNotDefinedRule(message) {
  var regex = /Definition for rule '(.+)' was not found\./;
  return regex.test(message);
}

// function filterReportBasedBranchDiff(reportJson, branch_diff_json) {
//   return new Promise((resolve) => {
//     if (!branch_diff_json) {
//       Logger.log(Logger.FAILURE_TYPE, "git diff json is not given ...");
//       resolve(false);
//     }
//     const impactLineMap = filterDiffJson(branch_diff_json);
//     reportJson = reportJson.filter((fileReport) => {
//       const isImpactFile = fileReport.filePath;
//       if (!isImpactFile || isImpactFile.includes(".feature")) {
//         return false;
//       }
//       const impactLinesArray = impactLineMap.get(isImpactFile)
//       if (impactLinesArray?.length !== 0) {
//         fileReport.messages = fileReport.messages.filter((errorMsg) => {
//           if (impactLinesArray.includes(errorMsg.line)) {
//             return true;
//           }
//           return false;
//         });
//         return true;
//       }
//     });
//     resolve(reportJson);
//   });
// }