"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getModifiedLines = getModifiedLines;
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var _require = require("../utils/logger"),
  Logger = _require.Logger;
function getModifiedLines(content) {
  var diffLinesArr = [];
  var removedLines = [];
  try {
    var diffLineContentIter = content.split("\n");
    var addLineFrom = -1;
    var removeLineFrom = -1;
    var affectedLineNum = 0;
    var addedLineSubtractor = 0;
    var isRemovedLineAdded = false;
    var tempDiffLinesArr = new Set();
    var removedContent = "";
    var addedContent = "";
    var _iterator = _createForOfIteratorHelper(diffLineContentIter),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var currentDiffLine = _step.value;
        if (addLineFrom !== -1 && removeLineFrom !== -1 && currentDiffLine || currentDiffLine.startsWith("@")) {
          if (currentDiffLine.startsWith("@")) {
            // console.log('currentDiffLine',currentDiffLine)
            isRemovedLineAdded = false;
            if (tempDiffLinesArr.size > 0 && addedContent !== removedContent) {
              tempDiffLinesArr.forEach(function (line) {
                return diffLinesArr.push(line);
              });
            }
            if (removedContent && !addedContent) {
              tempDiffLinesArr.forEach(function (line) {
                return removedLines.push(line);
              });
            }
            removedContent = "";
            addedContent = "";
            tempDiffLinesArr.clear();
            var lineNos = currentDiffLine.split("@@")[1].trim().split(" ");
            // console.log('lineNos',lineNos)
            var removedLineDetail = lineNos[0].replace(/-/g, "").split(",");
            // console.log('removedLineDetail',removedLineDetail)
            var addedLineDetail = lineNos[1].replace(/\+/g, "").split(",");
            // console.log('addedLineDetail',addedLineDetail)

            addLineFrom = parseInt(addedLineDetail[0]);
            removeLineFrom = parseInt(removedLineDetail[0]) + addedLineSubtractor;
            affectedLineNum = removedLineDetail.length > 1 && parseInt(removedLineDetail[1]) > 0 ? removeLineFrom : addLineFrom;
          } else {
            // console.log('currentDiffLine - else',currentDiffLine)
            var isLineChanged = (currentDiffLine.startsWith("+") || currentDiffLine.startsWith("-") && !isRemovedLineAdded) && currentDiffLine.trim().length > 1;
            var currentDiffContent = currentDiffLine.substring(1).trim();

            // console.log('addedLineSubtractor-else',addedLineSubtractor)
            // console.log('removedContent-else',removedContent)
            // console.log('addedContent-else',addedContent)
            if (currentDiffLine.startsWith("-")) {
              addedLineSubtractor--;
              removedContent += currentDiffContent;
            } else if (currentDiffLine.startsWith("+")) {
              addedLineSubtractor++;
              addedContent += currentDiffContent;
            }
            if (isLineChanged) {
              tempDiffLinesArr.add(affectedLineNum);
            }
            if (!currentDiffLine.startsWith("-")) {
              affectedLineNum++;
            }
            isRemovedLineAdded = !isRemovedLineAdded && currentDiffLine.startsWith("-") && currentDiffLine.trim().length > 1 || isRemovedLineAdded && currentDiffLine.startsWith("-");
            // console.log('isRemovedLineAdded',isRemovedLineAdded)
          }
        }
      }
      // console.log('tempDiffLinesArr',tempDiffLinesArr)
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    if (tempDiffLinesArr.size > 0 && addedContent !== removedContent) {
      tempDiffLinesArr.forEach(function (line) {
        return diffLinesArr.push(line);
      });
      if (removedContent && !addedContent) {
        tempDiffLinesArr.forEach(function (line) {
          return removedLines.push(line);
        });
      }
    }
  } catch (exp) {
    Logger.log(Logger.FAILURE_TYPE, "Exception Occurred:".concat(exp));
  }
  return {
    modifiedLines: diffLinesArr,
    removedLines: removedLines
  };
}